#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <limits.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>


int main(int argc, char** argv) {
	char fullpath[PATH_MAX + 10];
	int err;
	struct stat st;
	struct dirent *ent;
	int dfd = -1;
	DIR *dir;

	dfd = open(argv[1], O_RDONLY);
	if (dfd == -1) {
		printf("error: open!\n");
		return 1;
	}

	dir = fdopendir(dfd);
	if (!dir) {
		printf("error: dir!\n");
		return 1;
	}

	while ((ent = readdir(dir))) {
		if (!strcmp(ent->d_name, ".") || !strcmp(ent->d_name, ".."))
			continue;

		err = fstatat(dfd, ent->d_name, &st, AT_SYMLINK_NOFOLLOW);
		if (err == -1) {
			printf("error: fstatat failed on %s\n", ent->d_name);
			printf("dfd: %i\n", dfd);
			break;
		}
	}

	close(dfd);

	return 0;
}
